var g_includeDirs = [
	".",
	"C:\\Program Files\\microsoft visual studio 9.0\\vc\\include"
];
var g_fso = new ActiveXObject("Scripting.FileSystemObject");
var g_indentLevel = 0;
var ForReading = 1;
var g_included = new Object;

function LocateHeader(name)
{
	for (var dir in g_includeDirs)
	{
		var path = g_includeDirs[dir] + "\\" + name;
		if (g_fso.FileExists(path))
		{
			return path;
		}
	}
	return name;
}

function ProcessHeader(name)
{
	var indent = "";
	for (var i = 0; i < g_indentLevel; i++)
	{
		indent += "  ";
	}
	WScript.Echo(indent + name);
	var path = LocateHeader(name);
	if (g_fso.FileExists(path) && !g_included[path])
	{
		g_included[path] = true;
		var header = g_fso.OpenTextFile(path, ForReading)
		++g_indentLevel;
		ProcessFile(header);
		--g_indentLevel;
		header.Close();
	}
}

function ProcessFile(stream)
{
	var include = /^\#include <(.*)>/;
	while (!stream.AtEndOfStream)
	{
		var line = stream.ReadLine();
		var match = include.exec(line);
		if (match)
		{
			ProcessHeader(match[1]);
		}
	}
}

function Main()
{
	g_indentLevel = 0;
	ProcessFile(WScript.StdIn);
}

Main();
